#include "paddle.h"
#include "graphics.h"

//=============================================================================
// default constructor
//=============================================================================
Paddle::Paddle() : Entity()
{
    spriteData.width = paddleNS::WIDTH;         // size of paddle
    spriteData.height = paddleNS::HEIGHT;
    spriteData.x = paddleNS::X;                 // location on screen
    spriteData.y = paddleNS::Y;
    spriteData.rect.bottom = paddleNS::HEIGHT;  // rectangle to select parts of an image
    spriteData.rect.right = paddleNS::WIDTH;
    frameDelay = 1;
    startFrame = 0;                             // first frame of animation
    endFrame     = 0;                           // last frame of animation
    currentFrame = startFrame;
    edge.top = -paddleNS::HEIGHT/2;             // set collision edges
    edge.bottom = paddleNS::HEIGHT/2;
    edge.left = -paddleNS::WIDTH/2;
    edge.right = paddleNS::WIDTH/2;
	collisionType = entityNS::ROTATED_BOX;
    mass = paddleNS::MASS;
}

//=============================================================================
// update
// typically called once per frame
// frameTime is used to regulate the speed of movement and animation
//=============================================================================
void Paddle::update(float frameTime)
{
    Entity::update(frameTime);

	//player movement
	  if (input->isKeyDown(W_KEY))
		{
			 deltaV.x += frameTime * paddleNS::SPEED;
		}

	  if(input->isKeyDown(S_KEY))
		{
	  	 	 deltaV.x -= frameTime * paddleNS::SPEED;
		}
      if (input->isKeyDown(UP_KEY))
		{
			 deltaV.y += frameTime * paddleNS::SPEED;
		}

      if(input->isKeyDown(DOWN_KEY))
		{
	  	 	 deltaV.y -= frameTime * paddleNS::SPEED;
		}
	
	  if (input->isKeyDown(W_KEY) && input->isKeyDown(S_KEY))
		   {setVelocityX(getVelocityX() * -.05);}
	  if (input->isKeyDown(DOWN_KEY) && input->isKeyDown(UP_KEY))
		   {setVelocityY(getVelocityY() * -.05);}

		spriteData.x = ((GAME_HEIGHT/2 + 128) + (((GAME_HEIGHT/8)*3) * cos(spriteData.angle)));
		spriteData.y = ((GAME_HEIGHT/2 -50) + (((GAME_HEIGHT/8)*3) * sin(spriteData.angle)));
		
		setRotatedBoxReady(false);
}
